package grafy;

import java.util.ArrayList;
import java.util.Scanner;

public class Graf {
	
	private int n;
	private int m;
	private  ArrayList<ArrayList<Integer>> listasas;
	
	/**
	 * tworzy graf bezkrawdziowy o zadanej przez n liczbie wierzchokw
	 * @param n liczba wierzcholkw grafu. Jeeli n<0 konstruktor zgasza wyjtek IllegalArgumentException
	 */
	public Graf(int n)
	{
		if(n<0) throw new IllegalArgumentException("Liczba wierzchokw nie moe by ujemna");	
		this.n=n;
		this.m=0;
		listasas= new ArrayList<ArrayList<Integer>>(n);
	     for(int i=0;i<n;i++)
	     {
	    	 listasas.add(i, new ArrayList<Integer>());
	     }
	}
	
	/**
	 * tworzy graf zgodnie z danymi pobieranymi ze strumienia in
	 * @param in strumie z ktrego odczytujemy rzd i krawdzie grafu
	 */	
	public Graf(Scanner in) 
	{   this(in.nextInt());	
		while(in.hasNextInt())
		{
			this.dodajKr(in.nextInt(), in.nextInt());
		}
	}
	
	

	
	/**
	 * Zwraca rzd grafu.
	 * @return rzd grafu
	 */
	public int n() {
		return n;
	}
	
	/**
	 * Zwraca rozmiar grafu.
	 * @return rozmiar grafu
	 */
	public int m() {
		return m;
	}

	/**
	 * Sprawdza, czy u jest wierzchokiem grafu
	 * @param u dany wierzchoek
	 * @return true jeeli u jest wierzchokiem grafu, false w przeciwnym przypadku
	 */
	public boolean czyWierzch(int u){
		if(u<0||u>n-1) return false;
		return true;
	}
	
	/**
	 * Sprawdza, czy uw jest krawdzi grafu.
	 * @param u wierzchoek grafu
	 * @param w wierzchoek grafu
	 * @return true jeeli krawd uw istnieje, false w przeciwnym przypadku
	 */
	public boolean czyKrawedz(int u, int w)
	{	if(czyWierzch(u)&&czyWierzch(w))
	{
		if(listasas.get(u).contains(w))//wystarczy sprawdzi jedn list ssiedztwa
			return true;
		else
			return false;}
	else
		return false;
	}	
	
	/**
	 * Dodaje now krawd uw do grafu. W przypadku gdy krawd uw ju naley do grafu dodaje krawd wielokrotn
	 * @param u wierzchoek grafu
	 * @param w wierzchoek grafu
	 * @return true jeeli u i w s wierzchokami grafu, false w przeciwnym przypadku.
	 */
	public boolean dodajKr(int u, int w) {
		if(czyWierzch(u)&&czyWierzch(w))
		{
			listasas.get(u).add(w);
			listasas.get(w).add(u);
			m++;
			return true;
		}
		else
			return false;	
	}

		//wypisuje graf w postaci acucha znakw
		public String toString(){
			StringBuilder s=new StringBuilder();
			s.append("n="+n+" m="+m+"\n");			
			for (int i=0;i<n;i++)
			{
				s.append(i+" ");
				s.append(listasas.get(i).toString()+"\n");
			}
			return s.toString();
		}
	
	/**
	 * Zwraca kopi kolekcji zawierajcej ssiadw u.
	 * @param u
	 * @return kolekcja ArrayList zawierajca ssiadw u, 
	 * jeeli u nie jest wierzchokiem grafu, zgasza wyjtek IllegalArgumentException
	 */
	@SuppressWarnings("unchecked")
	public ArrayList<Integer> sasiedzi(int u)
	{
		if (czyWierzch(u))
			return (ArrayList<Integer>) listasas.get(u).clone();
		else throw new IllegalArgumentException(u+" nie jest wierzchokiem tego grafu");	
	}
}
